﻿using System;

namespace David.Academy.ProgrammingInCSharp.CSharpBasics
{
	class Operations
	{
		void DoSomething()
		{
			#region булеви операции

			bool hasFood = true;
			hasFood = !hasFood;

			#endregion

			#region побитови операции

			int someBitmask = 13; // 00001101
			someBitmask = ~someBitmask; // 11110010

			#endregion

			#region аритметични операции

			int a = 2, b = 3, c = -1;
			int sum = a + b * c;

			#endregion

			#region тернарен оператор (оператор "? :")

			sum = a < 0 ? -1 : 1;
			// горният ред е аналогичен на следното:
			if (a < 0)
				sum = -1;
			else
				sum = 1;

			#endregion

			#region нулируем тип данни и null-coealescing

			decimal? averageMark = 5;
			// null-coalescing (оператор "??")
			Console.WriteLine(averageMark ?? 0);
			// горният ред е аналогичен на следното:
			if (averageMark == null)
				Console.WriteLine(0);
			else
				Console.WriteLine(averageMark);

			#endregion
		}
	}
}
