﻿using System;

namespace David.Academy.ProgrammingInCSharp.Conditions
{
	class Program
	{
		static void Main(string[] args)
		{
			Console.Write("Input an integer: ");
			int number = int.Parse(Console.ReadLine());

			// Сравнение
			Console.WriteLine("{0} is even: {1}", number, (number % 2 == 0));

			// Конюнкция
			Console.WriteLine("{0} is between 0 and 100: {1}", number, ((number >= 0) && (number <= 100)));

			// Доказателство за мързеливо пресмятане
			// (функцията CheckSomething() не се изпълнява при пресмятането на стойността на променливата b)
			Console.WriteLine("Calling CheckSomething().");
			CheckSomething();
			Console.WriteLine("Performing lazy evaluation.");
			bool b = (false && CheckSomething());
			Console.WriteLine(b);

			Console.ReadLine();
		}

		static bool CheckSomething()
		{
			Console.WriteLine("CheckSomething() was called.");
			return true;
		}
	}
}
