﻿using System;

namespace David.Academy.ProgrammingInCSharp.Arrays
{
	class Program
	{
		#region Деклариране, инстанциране и обходждане на едномерни масиви

		static void Main(string[] args)
		{
			// Деклариране и инстанциране на масив
			double[] numbers;
			numbers = new double[] { 5.3, -1, 0, 16, 99249568496, -4 };

			// Достъпване на елементите на масив
			//Console.WriteLine("numbers[4] = {0}", numbers[4]);
			//numbers[4] = 3.333;
			//Console.WriteLine("numbers[4] = {0}", numbers[4]);

			// Обходждане на масив
			for (int i = 0; i < numbers.Length; i++)
			{
				numbers[i] *= 2;
				Console.WriteLine(numbers[i]);
			}

			Console.WriteLine();

			// Обходждане на масив (в обратен ред)
			for (int i = numbers.Length - 1; i >= 0; i--)
			{
				Console.WriteLine(numbers[i]);
			}

			Console.WriteLine();

			// Обхождане на масив като изброима колекция
			foreach (double number in numbers)
			{
				Console.WriteLine(number);
			}

			Console.ReadLine();
		}

		#endregion

		#region Пример за няколко елемента на масив, които реферират едно място в паметта

		//static void Main(string[] args)
		//{
		//	string[] strings = new string[2];

		//	// Кратките символни низове се интернират, т.е. в паметта се пази само едно копие за всяка
		//	// уникална поредица от символи. По тази причина, въпреки че никъде изрично не сме указали,
		//	// че двата елемента на масива трябва да реферират едно място в паметта, това е изпълнено
		//	strings[0] = "Hello!";
		//	strings[1] = "Hello!";

		//	Console.WriteLine(strings[0] == strings[1]);
		//	Console.WriteLine(object.ReferenceEquals(strings[0], strings[1]));

		//	// Дългите символни низове не се интернират. Създаваме два еднакви дълги низа и можем да се
		//	// уверим, че двата елемента на масива не реферират едно и също място в паметта
		//	string s = string.Empty;
		//	for (int i = 0; i < 1000; i++)
		//	{
		//		s += "Hello! ";
		//	}
		//	strings[0] = s;

		//	s = string.Empty;
		//	for (int i = 0; i < 1000; i++)
		//	{
		//		s += "Hello! ";
		//	}
		//	strings[1] = s;

		//	Console.WriteLine(strings[0] == strings[1]);
		//	Console.WriteLine(object.ReferenceEquals(strings[0], strings[1]));

		//	// След като присвоим единия елемент на другия, двата елемента вече реферират едно и също
		//	// място в паметта
		//	strings[1] = strings[0];

		//	Console.WriteLine(strings[0] == strings[1]);
		//	Console.WriteLine(object.ReferenceEquals(strings[0], strings[1]));

		//	Console.ReadLine();
		//}

		#endregion
	}
}
