﻿using System;

namespace David.Academy.ProgrammingInCSharp.JaggedArrays
{
	class Program
	{
		static void Main(string[] args)
		{
			// Деклариране и инстанциране на назъбен масив от символни низове
			string[][] books =
			{
				new string[] { "Hobbit", "The Fellowship of the Ring", "Song of Fire and Ice" },
				new string[] { "50 Shades of Grey" },
				new string[0],
				null,
				new[] { "Програмиране = ++Алгоритми", "Visual C++ .NET" },
			};

			// Достъпване на елемент на външния масив
			books[3] = new string[] { "Биография на Христо Стоичков", null };
			// Достъпване на елемент на вътрешен масив в назъбения масив
			books[3][1] = "Volleyball for Dummies";

			///Console.WriteLine(books[1]);
			//Console.WriteLine(books[3][0]);

			// Обхождане на елементите (въшни и вътрешни) на назъбен масив
			for (int i = 0; i < books.Length; i++)
			{
				Console.Write("Жанр {0}: ", i);
				for (int j = 0; j < books[i].Length; j++)
				{
					Console.Write("\"{0}\", ", books[i][j]);
				}
				Console.WriteLine();
			}

			Console.WriteLine();

			// Обхождане на назъбен масив като вложени изброими колекции
			int c = 0;
			foreach (string[] genreBooks in books)
			{
				Console.Write("Жанр {0}: ", c);
				foreach (string book in genreBooks)
				{
					Console.Write("\"{0}\", ", book);
				}
				Console.WriteLine();
				c++;
			}

			Console.ReadLine();
		}
	}
}
