﻿using System;
using System.Numerics;

namespace David.Academy.ProgrammingInCSharp.Factorial
{
	class Program
	{
		static BigInteger GetFactorialIter(uint n)
		{
			// инициализация на резултата
			BigInteger result = 1;
			// последователно умножение на резултата по числата от 1 до n
			for (uint i = 1; i <= n; i++)
				result *= i;

			return result;
		}

		static BigInteger GetFactorialRec(uint n)
		{
			// дъно на рекурсията
			if (n == 0)
				return 1;
			// рекурсивно извикване
			return n * GetFactorialRec(n - 1);
		}

		static void Main(string[] args)
		{
			for (uint i = 0; i <= 25; i++)
			{
				//Console.WriteLine("GetFactorialter({0}) = {1}",
				//	i, GetFactorialIter(i));
				Console.WriteLine("GetFactorialRec({0}) = {1}",
					i, GetFactorialRec(i));
			}

			Console.ReadLine();
		}
	}
}
