﻿namespace David.Academy.ProgrammingInCSharp.Indexers
{
	/// <summary>
	/// Клас за книга
	/// </summary>
	class Book
	{
		/// <summary>
		/// Заглавие на книгата
		/// </summary>
		public string Title { get; private set; }
		/// <summary>
		/// Автор на книгата
		/// </summary>
		public string Author { get; private set; }

		/// <summary>
		/// Конструктор на книга с параметри заглави е автор
		/// </summary>
		/// <param name="title">Заглавие на книгата</param>
		/// <param name="author">Автор на книгата</param>
		public Book(string title, string author)
		{
			Title = title;
			Author = author;
		}
	}
}
