﻿using System;

namespace David.Academy.ProgrammingInCSharp.Primes
{
	class Program
	{
		static void Main(string[] args)
		{
			// Въвеждане на горната граница за намиране на прости числа
			Console.Write("n = ");
			int n = int.Parse(Console.ReadLine());

			// Деклариране и инициализация на масива от булеви стойности
			bool[] isPrime = new bool[n];
			for (int i = 2; i < isPrime.Length; i++)
			{
				isPrime[i] = true;
			}

			// Обхождане на масива, за да се отсеят съставните числа
			for (int i = 0; i < isPrime.Length; i++)
			{
				// Ако текущият индекс не е просто число, стъпката се пропуска
				if (!isPrime[i])
					continue;

				// Ако текущият индекс е просто число, на всички следващи елементи
				// с кратни на него индекси се присвоява стойност false
				for (int j = i * 2; j < isPrime.Length; j += i)
				{
					isPrime[j] = false;
				}
			}

			// Извеждане на простите числа (индексите, за които съответният елемент
			// има стойност true)
			for (int i = 0; i < isPrime.Length; i++)
			{
				if (isPrime[i])
					Console.Write("{0}, ", i);
			}

			Console.ReadLine();
		}
	}
}
