﻿using System;

namespace David.Academy.ProgrammingInCSharp.ReverseArray
{
	class Program
	{
		static void ShowArray(int[] a)
		{
			for (int i = 0; i < a.Length; i++)
				Console.Write(a[i] + " ");
			Console.WriteLine();
		}

		static void ReverseArrayRec(int[] a, int start, int end)
		{
			ShowArray(a);

			// началото и края (се опитват да) се разминават
			if (end <= start)
				return;

			// разменяме крайните елементи на масива
			int t = a[end];
			a[end] = a[start];
			a[start] = t;

			// обръщаме вътрешния подмасив
			ReverseArrayRec(a, start + 1, end - 1);
		}

		static void Main(string[] args)
		{
			int[] a = new[] { 7, -5, 40, 1, 34, 6, 1, -30, 14, 0 };
			ReverseArrayRec(a, 0, a.Length - 1);
			Console.ReadLine();
		}
	}
}
