﻿using System;

namespace David.Academy.ProgrammingInCSharp.Structs
{
	/// <summary>
	/// Главен клас на програмата
	/// </summary>
	class Program
	{
		/// <summary>
		/// Главна програма
		/// </summary>
		/// <param name="args">Аргументи от командния ред</param>
		static void Main(string[] args)
		{
			// Деклариране на променлива от структурен тип Movie с инициализация
			Movie saw = new Movie();
			// Попълване на полетата на структурата
			saw.OriginalTitle = "Saw";
			saw.BulgarianTitle = "Убийствен пъзел";
			saw.Year = 2004;

			// Изпечатване на низово представяне на структурата
			Console.WriteLine(saw);
			// Изпечатване на информация за филма
			Console.WriteLine(saw.OriginalTitle);
			Console.WriteLine(saw.BulgarianTitle);
			Console.WriteLine(saw.Year);

			// Деклариране на променлива от структурен тип Ticket
			Ticket myTicket;
			// Опит за четене на поле на неинициализирана структура - грешка при компилация
			//Console.WriteLine(myTicket.Destination);
			
			// Попълване на полетата на структурата, без да е инициализирана изрично
			myTicket.Destination = "София";
			myTicket.PurchaseDate = new DateTime(2014, 2, 9);
			myTicket.Price = 13.70;

			// Изпечатване на информация за билета
			Console.WriteLine(myTicket.Destination);
			Console.WriteLine(myTicket.PurchaseDate);
			Console.WriteLine(myTicket.Price);

			Console.ReadLine();
		}
	}
}
