﻿namespace David.Academy.ProgrammingInCSharp.Properties
{
	/// <summary>
	/// Клас за животно
	/// </summary>
	class Animal
	{
		// Частно поле за съхранение на името на животното
		private string _name;
		// Частно поле, указващо дали животното е женско;
		// Не се декларира от програмиста при използване на автоматично генерирано свойство IsFemale
		//private bool _isFemale;

		// Метод-аксесор за прочитане на името на животното;
		// заменя се от get блока на свойството Name
		//public string GetName()
		//{
		//	return Name;
		//}

		// Метод - мутатор за промяна на името на животното;
		// заменя се от set блока на свойството Name
		//public void SetName(string name)
		//{
		//	Name = name;
		//}

		/// <summary>
		/// Свойство за име на животното
		/// </summary>
		public string Name
		{
			// Блок за прочитане на името на животното
			get
			{
				//Console.WriteLine("The property Name was accessed.");
				return _name;
			}
			// Блок за промяна на името на животното
			set
			{
				//Console.Write("The property Name was assigned the value {0}.", value);
				_name = value;
				//_isFemale = value.EndsWith("a");
				IsFemale = value.EndsWith("a");
			}
		}

		// Свойство само за четене, указващо дали животното е женско;
		// Заменено с автоматично генерираното свойство по-долу
		//public bool IsFemale
		//{
		//	get { return _isFemale; }
		//}

		/// <summary>
		/// Автоматично генерирано свойство, указващо дали животното е женско;
		/// Достъпът за четене на свойството е публичен, а достъпът за запис - частен
		/// </summary>
		public bool IsFemale { get; private set; }
	}
}
