﻿using System;

namespace David.Academy.ProgrammingInCSharp.Properties
{
	/// <summary>
	/// Главен клас на програмата
	/// </summary>
	class Program
	{
		/// <summary>
		/// Главна програма
		/// </summary>
		/// <param name="args">Аргументи от командния ред</param>
		static void Main(string[] args)
		{
			// Създаване на екземпляр на класа Animal
			Animal dog = new Animal();

			// Присвояване на стойност на свойството Name
			dog.Name = "Hera";
			// Присвояване на стойност на името на кучето, ако трябва да се използва метод-аксесор вместо свойство
			//dog.SetName("Sharo");

			// Прочитане на стойността на свойствотата Name и IsFemale
			Console.WriteLine("The dog's name is {0}", dog.Name);
			Console.WriteLine("{0} is female: {1}", dog.Name, dog.IsFemale);
			// Опит за присвояване на стойност на свойството IsFemale;
			// Предизвиква грешка при компилация, тъй като блокът за запис на свойството е с частна видимост
			//dog.IsFemale = false;

			// Създаване на екземпляр на класа Test
			Test test = new Test("Maths");

			// Прочитане на стойността на свойствотата Subject и IsInteresting
			Console.WriteLine("The test's subject is {0}.", test.Subject);
			Console.WriteLine("The test's subject is interesting: {0}", test.IsInteresting);
			// Опит за присвояване на стойност на свойството IsInteresting;
			// Предизвиква грешка при компилация, тъй като блокът за запис на свойството е с частна видимост
			//test.IsInteresting = false;

			// Създаване на екземпляр на класа Square
			Square square = new Square();

			// Присвояване на стойност на свойството Side
			square.Side = 4;
			// Опит за присвояване на стойност на свойството Area;
			// Предизвиква грешка при компилация, тъй като блокът за запис на свойството е със защитена видимост
			//square.Area = 6;
			Console.WriteLine("Square area: {0}", square.Area);

			Console.ReadLine();
		}
	}
}
