﻿namespace David.Academy.ProgrammingInCSharp.Properties
{
	/// <summary>
	/// Клас за произволна равнинна фигура
	/// </summary>
	class Shape2D
	{
		// Частно поле за съхранение на площта на фигурата
		private double _area;

		/// <summary>
		/// Свойство за площ на фигурата
		/// </summary>
		public double Area
		{
			// Блок за прочитане на площта на фигурата
			get { return _area; }
			// Блок със защитена видимост за промяна на площта на фигурата
			protected set
			{
				if (value > 0.0)
					_area = value;
			}
		}
	}
}
