﻿using System;

namespace David.Academy.ProgrammingInCSharp.Abstraction
{
	/// <summary>
	/// Абстрактен клас за произволна равнинна фигура
	/// </summary>
	abstract class Shape2D
	{
		/// <summary>
		/// Абстракно свойство само за четене за периметър на равнинната фигура
		/// </summary>
		public abstract double Perimeter { get; }

		/// <summary>
		/// Абстрактно свойство само за четене за лице на равнинната фигура
		/// </summary>
		public abstract double Area { get; }

		/// <summary>
		/// Абстрактен метод за въвеждане на характеристиките на равнинната фигура от конзолата
		/// </summary>
		public abstract void InputFromConsole();

		/// <summary>
		/// Виртуален метод за извеждане на характеристиките на равнинната фигура на конзолата
		/// </summary>
		public virtual void PrintToConsole()
		{
			Console.WriteLine("Perimeter = {0}", Perimeter);
			Console.WriteLine("Area = {0}", Area);
		}
	}
}
